let canvasEl,context,callbacks={};function on(t,e){callbacks[t]=callbacks[t]||[],callbacks[t].push(e)}function off(t,e){callbacks[t]=(callbacks[t]||[]).filter((t=>t!=e))}function emit(t,...e){(callbacks[t]||[]).map((t=>t(...e)))}function getCanvas(){return canvasEl}function getContext(){return context}function init(t){if(canvasEl=document.getElementById(t)||t||document.querySelector("canvas"),!canvasEl)throw Error("You must provide a canvas element for the game");return context=canvasEl.getContext("2d"),context.imageSmoothingEnabled=!1,emit("init"),{canvas:canvasEl,context:context}}class Animation{constructor({spriteSheet:t,frames:e,frameRate:i,loop:s=!0}){this.spriteSheet=t,this.frames=e,this.frameRate=i,this.loop=s;let{width:n,height:a,margin:o=0}=t.frame;this.width=n,this.height=a,this.margin=o,this._f=0,this._a=0}clone(){return new Animation(this)}reset(){this._f=0,this._a=0}update(t=1/60){if(this.loop||this._f!=this.frames.length-1)for(this._a+=t;this._a*this.frameRate>=1;)this._f=++this._f%this.frames.length,this._a-=1/this.frameRate}render({x:t,y:e,width:i=this.width,height:s=this.height,context:n=getContext()}){let a=this.frames[this._f]/this.spriteSheet._f|0,o=this.frames[this._f]%this.spriteSheet._f|0;n.drawImage(this.spriteSheet.image,o*this.width+(2*o+1)*this.margin,a*this.height+(2*a+1)*this.margin,this.width,this.height,t,e,i,s)}}function factory(){return new Animation(...arguments)}factory.prototype=Animation.prototype,factory.class=Animation;let imageRegex=/(jpeg|jpg|gif|png|webp)$/,audioRegex=/(wav|mp3|ogg|aac)$/,leadingSlash=/^\//,trailingSlash=/\/$/,dataMap=new WeakMap,imagePath="",audioPath="",dataPath="";function getUrl(t,e){return new URL(t,e).href}function joinPath(t,e){return[t.replace(trailingSlash,""),t?e.replace(leadingSlash,""):e].filter((t=>t)).join("/")}function getExtension(t){return t.split(".").pop()}function getName(t){let e=t.replace("."+getExtension(t),"");return 2==e.split("/").length?e.replace(leadingSlash,""):e}function getCanPlay(t){return{wav:t.canPlayType('audio/wav; codecs="1"'),mp3:t.canPlayType("audio/mpeg;"),ogg:t.canPlayType('audio/ogg; codecs="vorbis"'),aac:t.canPlayType("audio/aac;")}}let imageAssets={},audioAssets={},dataAssets={};function addGlobal(){window.__k||(window.__k={dm:dataMap,u:getUrl,d:dataAssets,i:imageAssets})}function setImagePath(t){imagePath=t}function setAudioPath(t){audioPath=t}function setDataPath(t){dataPath=t}function loadImage(t){return addGlobal(),new Promise(((e,i)=>{let s,n,a;if(s=joinPath(imagePath,t),imageAssets[s])return e(imageAssets[s]);n=new Image,n.onload=function(){a=getUrl(s,window.location.href),imageAssets[getName(t)]=imageAssets[s]=imageAssets[a]=this,emit("assetLoaded",this,t),e(this)},n.onerror=function(){i("Unable to load image "+s)},n.src=s}))}function loadAudio(t){return new Promise(((e,i)=>{let s,n,a,o,r=t;return s=new Audio,n=getCanPlay(s),(t=[].concat(t).reduce(((t,e)=>t||(n[getExtension(e)]?e:null)),0))?(a=joinPath(audioPath,t),audioAssets[a]?e(audioAssets[a]):(s.addEventListener("canplay",(function(){o=getUrl(a,window.location.href),audioAssets[getName(t)]=audioAssets[a]=audioAssets[o]=this,emit("assetLoaded",this,t),e(this)})),s.onerror=function(){i("Unable to load audio "+a)},s.src=a,void s.load())):i("cannot play any of the audio formats provided "+r)}))}function loadData(t){let e,i;return addGlobal(),e=joinPath(dataPath,t),dataAssets[e]?Promise.resolve(dataAssets[e]):fetch(e).then((t=>{if(!t.ok)throw t;return t.clone().json().catch((()=>t.text()))})).then((s=>(i=getUrl(e,window.location.href),"object"==typeof s&&dataMap.set(s,i),dataAssets[getName(t)]=dataAssets[e]=dataAssets[i]=s,emit("assetLoaded",s,t),s)))}function load(...t){return addGlobal(),Promise.all(t.map((t=>{let e=getExtension([].concat(t)[0]);return e.match(imageRegex)?loadImage(t):e.match(audioRegex)?loadAudio(t):loadData(t)})))}function degToRad(t){return t*Math.PI/180}function radToDeg(t){return 180*t/Math.PI}function angleToTarget(t,e){return Math.atan2(e.y-t.y,e.x-t.x)+Math.PI/2}function rotatePoint(t,e){let i=Math.sin(e),s=Math.cos(e);return{x:t.x*s-t.y*i,y:t.x*i+t.y*s}}function randInt(t,e){return Math.floor(Math.random()*(e-t+1))+t}function seedRand(t){for(var e=0,i=2166136261;e<t.length;e++)i=Math.imul(i^t.charCodeAt(e),16777619);i+=i<<13,i^=i>>>7,i+=i<<3,i^=i>>>17;let s=(i+=i<<5)>>>0,n=()=>(2**31-1&(s=Math.imul(48271,s)))/2**31;return n(),n}function lerp(t,e,i){return t*(1-i)+e*i}function inverseLerp(t,e,i){return(i-t)/(e-t)}function clamp(t,e,i){return Math.min(Math.max(t,i),e)}function setStoreItem(t,e){void 0===e?localStorage.removeItem(t):localStorage.setItem(t,JSON.stringify(e))}function getStoreItem(t){let e=localStorage.getItem(t);try{e=JSON.parse(e)}catch(t){}return e}function collides(t,e){return t.rotation||e.rotation?null:([t,e]=[t,e].map((t=>getWorldRect(t))),t.x<e.x+e.width&&t.x+t.width>e.x&&t.y<e.y+e.height&&t.y+t.height>e.y)}function getWorldRect(t){let{x:e=0,y:i=0,width:s,height:n}=t.world||t;return t.mapwidth&&(s=t.mapwidth,n=t.mapheight),t.anchor&&(e-=s*t.anchor.x,i-=n*t.anchor.y),s<0&&(e+=s,s*=-1),n<0&&(i+=n,n*=-1),{x:e,y:i,width:s,height:n}}class Vector{constructor(t=0,e=0,i={}){this.x=t,this.y=e,i._c&&(this.clamp(i._a,i._b,i._d,i._e),this.x=t,this.y=e)}add(t){return new Vector(this.x+t.x,this.y+t.y,this)}subtract(t){return new Vector(this.x-t.x,this.y-t.y,this)}scale(t){return new Vector(this.x*t,this.y*t)}normalize(t=this.length()){return new Vector(this.x/t,this.y/t)}dot(t){return this.x*t.x+this.y*t.y}length(){return Math.hypot(this.x,this.y)}distance(t){return Math.hypot(this.x-t.x,this.y-t.y)}angle(t){return Math.acos(this.dot(t)/(this.length()*t.length()))}clamp(t,e,i,s){this._c=!0,this._a=t,this._b=e,this._d=i,this._e=s}get x(){return this._x}get y(){return this._y}set x(t){this._x=this._c?clamp(this._a,this._d,t):t}set y(t){this._y=this._c?clamp(this._b,this._e,t):t}}function factory$1(){return new Vector(...arguments)}factory$1.prototype=Vector.prototype,factory$1.class=Vector;class Updatable{constructor(t){return this.init(t)}init(t={}){this.position=factory$1(),this.velocity=factory$1(),this.acceleration=factory$1(),this.ttl=1/0,Object.assign(this,t)}update(t){this.advance(t)}advance(t){let e=this.acceleration;t&&(e=e.scale(t)),this.velocity=this.velocity.add(e);let i=this.velocity;t&&(i=i.scale(t)),this.position=this.position.add(i),this._pc(),this.ttl--}get dx(){return this.velocity.x}get dy(){return this.velocity.y}set dx(t){this.velocity.x=t}set dy(t){this.velocity.y=t}get ddx(){return this.acceleration.x}get ddy(){return this.acceleration.y}set ddx(t){this.acceleration.x=t}set ddy(t){this.acceleration.y=t}isAlive(){return this.ttl>0}_pc(){}}let noop=()=>{},srOnlyStyle="position:absolute;width:1px;height:1px;overflow:hidden;";function addToDom(t,e){let i=e.parentNode;if(t.setAttribute("data-kontra",""),i){let s=i.querySelector("[data-kontra]:last-of-type")||e;i.insertBefore(t,s.nextSibling)}else document.body.appendChild(t)}class GameObject extends Updatable{init({width:t=0,height:e=0,context:i=getContext(),render:s=this.draw,update:n=this.advance,children:a=[],anchor:o={x:0,y:0},sx:r=0,sy:h=0,opacity:c=1,rotation:l=0,scaleX:d=1,scaleY:u=1,...p}={}){this.children=[],super.init({width:t,height:e,context:i,anchor:o,sx:r,sy:h,opacity:c,rotation:l,scaleX:d,scaleY:u,...p}),this._di=!0,this._uw(),a.map((t=>this.addChild(t))),this._rf=s,this._uf=n}update(t){this._uf(t),this.children.map((e=>e.update&&e.update(t)))}render(t){let e=this.context;e.save(),(this.x||this.y)&&e.translate(this.x,this.y),this.rotation&&e.rotate(this.rotation),(this.sx||this.sy)&&e.translate(-this.sx,-this.sy),1==this.scaleX&&1==this.scaleY||e.scale(this.scaleX,this.scaleY);let i=-this.width*this.anchor.x,s=-this.height*this.anchor.y;(i||s)&&e.translate(i,s),this.context.globalAlpha=this.opacity,this._rf(),(i||s)&&e.translate(-i,-s);let n=this.children;t&&(n=n.filter(t)),n.map((t=>t.render&&t.render())),e.restore()}draw(){}_pc(t,e){this._uw(),this.children.map((t=>t._pc()))}get x(){return this.position.x}get y(){return this.position.y}set x(t){this.position.x=t,this._pc()}set y(t){this.position.y=t,this._pc()}get width(){return this._w}set width(t){this._w=t,this._pc()}get height(){return this._h}set height(t){this._h=t,this._pc()}_uw(){if(!this._di)return;let{_wx:t=0,_wy:e=0,_wo:i=1,_wr:s=0,_wsx:n=1,_wsy:a=1}=this.parent||{};this._wx=this.x,this._wy=this.y,this._ww=this.width,this._wh=this.height,this._wo=i*this.opacity,this._wr=s+this.rotation;let{x:o,y:r}=rotatePoint({x:this.x,y:this.y},s);this._wx=o,this._wy=r,this._wsx=n*this.scaleX,this._wsy=a*this.scaleY,this._wx=this.x*n,this._wy=this.y*a,this._ww=this.width*this._wsx,this._wh=this.height*this._wsy,this._wx+=t,this._wy+=e}get world(){return{x:this._wx,y:this._wy,width:this._ww,height:this._wh,opacity:this._wo,rotation:this._wr,scaleX:this._wsx,scaleY:this._wsy}}addChild(t,{absolute:e=!1}={}){this.children.push(t),t.parent=this,t._pc=t._pc||noop,t._pc()}removeChild(t){let e=this.children.indexOf(t);-1!==e&&(this.children.splice(e,1),t.parent=null,t._pc())}get opacity(){return this._opa}set opacity(t){this._opa=t,this._pc()}get rotation(){return this._rot}set rotation(t){this._rot=t,this._pc()}setScale(t,e=t){this.scaleX=t,this.scaleY=e}get scaleX(){return this._scx}set scaleX(t){this._scx=t,this._pc()}get scaleY(){return this._scy}set scaleY(t){this._scy=t,this._pc()}}function factory$2(){return new GameObject(...arguments)}factory$2.prototype=GameObject.prototype,factory$2.class=GameObject;class Sprite extends factory$2.class{init({image:t,width:e=(t?t.width:void 0),height:i=(t?t.height:void 0),...s}={}){super.init({image:t,width:e,height:i,...s})}get animations(){return this._a}set animations(t){let e,i;for(e in this._a={},t)this._a[e]=t[e].clone(),i=i||this._a[e];this.currentAnimation=i,this.width=this.width||i.width,this.height=this.height||i.height}playAnimation(t){this.currentAnimation=this.animations[t],this.currentAnimation.loop||this.currentAnimation.reset()}advance(t){super.advance(t),this.currentAnimation&&this.currentAnimation.update(t)}draw(){this.image&&this.context.drawImage(this.image,0,0,this.image.width,this.image.height),this.currentAnimation&&this.currentAnimation.render({x:0,y:0,width:this.width,height:this.height,context:this.context}),this.color&&(this.context.fillStyle=this.color,this.context.fillRect(0,0,this.width,this.height))}}function factory$3(){return new Sprite(...arguments)}factory$3.prototype=Sprite.prototype,factory$3.class=Sprite;let fontSizeRegex=/(\d+)(\w+)/;function parseFont(t){let e=t.match(fontSizeRegex),i=+e[1];return{size:i,unit:e[2],computed:i}}class Text extends factory$2.class{init({text:t="",textAlign:e="",lineHeight:i=1,font:s=getContext().font,...n}={}){t=""+t,super.init({text:t,textAlign:e,lineHeight:i,font:s,...n}),this._p()}get width(){return this._w}set width(t){this._d=!0,this._w=t,this._fw=t}get text(){return this._t}set text(t){this._d=!0,this._t=t}get font(){return this._f}set font(t){this._d=!0,this._f=t,this._fs=parseFont(t).computed}get lineHeight(){return this._lh}set lineHeight(t){this._d=!0,this._lh=t}render(){this._d&&this._p(),super.render()}_p(){this._s=[],this._d=!1;let t=this.context;if(t.font=this.font,!this._s.length&&this._fw){let e=this.text.split(" "),i=0,s=2;for(;s<=e.length;s++){let n=e.slice(i,s).join(" ");t.measureText(n).width>this._fw&&(this._s.push(e.slice(i,s-1).join(" ")),i=s-1)}this._s.push(e.slice(i,s).join(" "))}if(!this._s.length&&this.text.includes("\n")){let e=0;this.text.split("\n").map((i=>{this._s.push(i),e=Math.max(e,t.measureText(i).width)})),this._w=this._fw||e}this._s.length||(this._s.push(this.text),this._w=this._fw||t.measureText(this.text).width),this.height=this._fs+(this._s.length-1)*this._fs*this.lineHeight,this._uw()}draw(){let t=0,e=this.textAlign,i=this.context;e=this.textAlign||("rtl"===i.canvas.dir?"right":"left"),t="right"===e?this.width:"center"===e?this.width/2|0:0,this._s.map(((s,n)=>{i.textBaseline="top",i.textAlign=e,i.fillStyle=this.color,i.font=this.font,i.fillText(s,t,this._fs*this.lineHeight*n)}))}}function factory$4(){return new Text(...arguments)}factory$4.prototype=Text.prototype,factory$4.class=Text;let pointers=new WeakMap,callbacks$1={},pressedButtons={},buttonMap={0:"left",1:"middle",2:"right"};function getPointer(t=getCanvas()){return pointers.get(t)}function circleRectCollision(t,e){let{x:i,y:s,width:n,height:a}=getWorldRect(t);do{i-=t.sx||0,s-=t.sy||0}while(t=t.parent);let o=e.x-Math.max(i,Math.min(e.x,i+n)),r=e.y-Math.max(s,Math.min(e.y,s+a));return o*o+r*r<e.radius*e.radius}function getCurrentObject(t){let e=t._lf.length?t._lf:t._cf;for(let i=e.length-1;i>=0;i--){let s=e[i];if(s.collidesWithPointer?s.collidesWithPointer(t):circleRectCollision(s,t))return s}}function getPropValue(t,e){return parseFloat(t.getPropertyValue(e))||0}function getCanvasOffset(t){let{canvas:e,_s:i}=t,s=e.getBoundingClientRect(),n="none"!==i.transform?i.transform.replace("matrix(","").split(","):[1,1,1,1],a=parseFloat(n[0]),o=parseFloat(n[3]),r=(getPropValue(i,"border-left-width")+getPropValue(i,"border-right-width"))*a,h=(getPropValue(i,"border-top-width")+getPropValue(i,"border-bottom-width"))*o,c=(getPropValue(i,"padding-left")+getPropValue(i,"padding-right"))*a,l=(getPropValue(i,"padding-top")+getPropValue(i,"padding-bottom"))*o;return{scaleX:(s.width-r-c)/e.width,scaleY:(s.height-h-l)/e.height,offsetX:s.left+(getPropValue(i,"border-left-width")+getPropValue(i,"padding-left"))*a,offsetY:s.top+(getPropValue(i,"border-top-width")+getPropValue(i,"padding-top"))*o}}function pointerDownHandler(t){let e=void 0!==t.button?buttonMap[t.button]:"left";pressedButtons[e]=!0,pointerHandler(t,"onDown")}function pointerUpHandler(t){let e=void 0!==t.button?buttonMap[t.button]:"left";pressedButtons[e]=!1,pointerHandler(t,"onUp")}function mouseMoveHandler(t){pointerHandler(t,"onOver")}function blurEventHandler(t){pointers.get(t.target)._oo=null,pressedButtons={}}function pointerHandler(t,e){t.preventDefault();let i=t.target,s=pointers.get(i),{scaleX:n,scaleY:a,offsetX:o,offsetY:r}=getCanvasOffset(s);if(-1!==["touchstart","touchmove","touchend"].indexOf(t.type)){s.touches={};for(var h=0;h<t.touches.length;h++)s.touches[t.touches[h].identifier]={id:t.touches[h].identifier,x:(t.touches[h].clientX-o)/n,y:(t.touches[h].clientY-r)/a,changed:!1};for(h=t.changedTouches.length;h--;){const i=t.changedTouches[h].identifier;void 0!==s.touches[i]&&(s.touches[i].changed=!0);let c=t.changedTouches[h].clientX,l=t.changedTouches[h].clientY;s.x=(c-o)/n,s.y=(l-r)/a;let d=getCurrentObject(s);d&&d[e]&&d[e](t),callbacks$1[e]&&callbacks$1[e](t,d)}}else{s.x=(t.clientX-o)/n,s.y=(t.clientY-r)/a;let i=getCurrentObject(s);i&&i[e]&&i[e](t),callbacks$1[e]&&callbacks$1[e](t,i),"onOver"==e&&(i!=s._oo&&s._oo&&s._oo.onOut&&s._oo.onOut(t),s._oo=i)}}function initPointer({radius:t=5,canvas:e=getCanvas()}={}){let i=pointers.get(e);if(!i){let s=window.getComputedStyle(e);i={x:0,y:0,radius:t,touches:{},canvas:e,_cf:[],_lf:[],_o:[],_oo:null,_s:s},pointers.set(e,i)}return e.addEventListener("mousedown",pointerDownHandler),e.addEventListener("touchstart",pointerDownHandler),e.addEventListener("mouseup",pointerUpHandler),e.addEventListener("touchend",pointerUpHandler),e.addEventListener("touchcancel",pointerUpHandler),e.addEventListener("blur",blurEventHandler),e.addEventListener("mousemove",mouseMoveHandler),e.addEventListener("touchmove",mouseMoveHandler),i._t||(i._t=!0,on("tick",(()=>{i._lf.length=0,i._cf.map((t=>{i._lf.push(t)})),i._cf.length=0}))),i}function track(...t){t.map((t=>{let e=t.context?t.context.canvas:getCanvas(),i=pointers.get(e);if(!i)throw new ReferenceError("Pointer events not initialized for the objects canvas");t._r||(t._r=t.render,t.render=function(){i._cf.push(this),this._r()},i._o.push(t))}))}function untrack(...t){t.map((t=>{let e=t.context?t.context.canvas:getCanvas(),i=pointers.get(e);if(!i)throw new ReferenceError("Pointer events not initialized for the objects canvas");t.render=t._r,t._r=0;let s=i._o.indexOf(t);-1!==s&&i._o.splice(s,1)}))}function pointerOver(t){let e=t.context?t.context.canvas:getCanvas(),i=pointers.get(e);if(!i)throw new ReferenceError("Pointer events not initialized for the objects canvas");return i._o.includes(t)&&getCurrentObject(i)===t}function onPointerDown(t){callbacks$1.onDown=t}function onPointerUp(t){callbacks$1.onUp=t}function pointerPressed(t){return!!pressedButtons[t]}class Button extends factory$3.class{init({padX:t=0,padY:e=0,text:i,onDown:s,onUp:n,...a}={}){super.init({padX:t,padY:e,...a}),this.textNode=factory$4({...i,context:this.context}),this.width||(this.width=this.textNode.width,this.height=this.textNode.height),track(this),this.addChild(this.textNode),this._od=s||noop,this._ou=n||noop;const o=this._dn=document.createElement("button");o.style=srOnlyStyle,o.textContent=this.text,o.addEventListener("focus",(()=>this.focus())),o.addEventListener("blur",(()=>this.blur())),o.addEventListener("keydown",(t=>this._kd(t))),o.addEventListener("keyup",(t=>this._ku(t))),addToDom(o,this.context.canvas),this._uw(),this._p()}get text(){return this.textNode.text}set text(t){this._d=!0,this.textNode.text=t}destroy(){this._dn.remove()}_p(){this.text!==this._dn.textContent&&(this._dn.textContent=this.text),this.textNode._p();let t=this.textNode.width+2*this.padX,e=this.textNode.height+2*this.padY;this.width=Math.max(t,this.width),this.height=Math.max(e,this.height),this._uw()}render(){this._d&&this._p(),super.render()}enable(){this.disabled=this._dn.disabled=!1,this.onEnable()}disable(){this.disabled=this._dn.disabled=!0,this.onDisable()}focus(){this.disabled||(this.focused=!0,document.activeElement!=this._dn&&this._dn.focus(),this.onFocus())}blur(){this.focused=!1,document.activeElement==this._dn&&this._dn.blur(),this.onBlur()}onOver(){this.disabled||(this.hovered=!0)}onOut(){this.hovered=!1}onEnable(){}onDisable(){}onFocus(){}onBlur(){}onDown(){this.disabled||(this.pressed=!0,this._od())}onUp(){this.disabled||(this.pressed=!1,this._ou())}_kd(t){"Enter"!=t.code&&"Space"!=t.code||this.onDown()}_ku(t){"Enter"!=t.code&&"Space"!=t.code||this.onUp()}}function factory$5(){return new Button(...arguments)}function clear(t){let e=t.canvas;t.clearRect(0,0,e.width,e.height)}function GameLoop({fps:t=60,clearCanvas:e=!0,update:i=noop,render:s,context:n=getContext(),blur:a=!1}={}){if(!s)throw Error("You must provide a render() function");let o,r,h,c,l,d=0,u=1e3/t,p=1/t,f=e?clear:noop,g=!0;function _(){if(r=requestAnimationFrame(_),g&&(h=performance.now(),c=h-o,o=h,!(c>1e3))){for(emit("tick"),d+=c;d>=u;)l.update(p),d-=u;f(n),l.render()}}return a||(window.addEventListener("focus",(()=>{g=!0})),window.addEventListener("blur",(()=>{g=!1}))),l={update:i,render:s,isStopped:!0,start(){o=performance.now(),this.isStopped=!1,requestAnimationFrame(_)},stop(){this.isStopped=!0,cancelAnimationFrame(r)},_frame:_,set _last(t){o=t}},l}factory$5.prototype=Button.prototype,factory$5.class=Button;let handler={set:(t,e,i)=>(e.startsWith("_")||(t._d=!0),Reflect.set(t,e,i))},alignment={start:t=>t?1:0,center:()=>.5,end:t=>t?0:1};class Grid extends factory$2.class{init({flow:t="column",align:e="start",justify:i="start",colGap:s=0,rowGap:n=0,numCols:a=1,dir:o="",breakpoints:r=[],...h}={}){return super.init({flow:t,align:e,justify:i,colGap:s,rowGap:n,numCols:a,dir:o,breakpoints:r,...h}),this._p(),new Proxy(this,handler)}addChild(t){this._d=!0,super.addChild(t)}removeChild(t){this._d=!0,super.removeChild(t)}render(){this._d&&this._p(),super.render()}destroy(){this.children.map((t=>t.destroy&&t.destroy()))}_p(){this._d=!1,this.breakpoints.map((t=>{t.metric.call(this)&&this._b!==t&&(this._b=t,t.callback.call(this))}));let t=this._g=[],e=this._cw=[],i=this._rh=[],s=this.children,n=this._nc="column"===this.flow?1:"row"===this.flow?s.length:this.numCols,a=0,o=0;for(let r,h=0;r=s[h];h++){t[a]=t[a]||[],r._p&&r._p(),i[a]=Math.max(i[a]||0,r.height);let s=r.colSpan||1,h=s;do{e[o]=Math.max(e[o]||0,r.width/h),t[a][o]=r}while(h+o++<=n&&--s);o>=n&&(o=0,a++)}for(;o>0&&o<n;)t[a][o++]=!1;let r=t.length,h=[].concat(this.colGap),c=[].concat(this.rowGap);this._w=e.reduce(((t,e)=>t+e),0);for(let t=0;t<n-1;t++)this._w+=h[t%h.length];this._h=i.reduce(((t,e)=>t+e),0);for(let t=0;t<r-1;t++)this._h+=c[t%c.length];this._uw();let l="rtl"===this.context.canvas.dir&&!this.dir||"rtl"===this.dir;this._rtl=l,l&&(this._g=t.map((t=>t.reverse())),this._cw=e.reverse(),h=h.reverse());let d=-this.anchor.y*this.height,u=[];this._g.map(((t,s)=>{let n=-this.anchor.x*this.width;t.map(((t,a)=>{if(t&&!u.includes(t)){u.push(t);let o=alignment[t.justifySelf||this.justify](this._rtl),r=alignment[t.alignSelf||this.align](),c=t.colSpan||1,l=e[a];if(c>1&&a+c<=this._nc)for(let t=1;t<c;t++)l+=e[a+t]+h[(a+t)%h.length];let p=l*o,f=i[s]*r,g=0,_=0,{width:y,height:m}=t;if(t.anchor&&(g=t.anchor.x,_=t.anchor.y),0===o)p+=y*g;else if(.5===o){p+=(g<.5?-1:.5===g?0:1)*y*o}else p-=y*(1-g);if(0===r)f+=m*_;else if(.5===r){f+=(_<.5?-1:.5===_?0:1)*m*r}else f-=m*(1-_);t.x=n+p,t.y=d+f}n+=e[a]+h[a%h.length]})),d+=i[s]+c[s%c.length]}))}}function factory$6(){return new Grid(...arguments)}factory$6.prototype=Grid.prototype,factory$6.class=Grid;let keydownCallbacks={},keyupCallbacks={},pressedKeys={},keyMap={Enter:"enter",Escape:"esc",Space:"space",ArrowLeft:"left",ArrowUp:"up",ArrowRight:"right",ArrowDown:"down"};function call(t=noop,e){t._pd&&e.preventDefault(),t(e)}function keydownEventHandler(t){let e=keyMap[t.code],i=keydownCallbacks[e];pressedKeys[e]=!0,call(i,t)}function keyupEventHandler(t){let e=keyMap[t.code],i=keyupCallbacks[e];pressedKeys[e]=!1,call(i,t)}function blurEventHandler$1(){pressedKeys={}}function initKeys(){let t;for(t=0;t<26;t++)keyMap[t+65]=keyMap["Key"+String.fromCharCode(t+65)]=String.fromCharCode(t+97);for(t=0;t<10;t++)keyMap[48+t]=keyMap["Digit"+t]=""+t;window.addEventListener("keydown",keydownEventHandler),window.addEventListener("keyup",keyupEventHandler),window.addEventListener("blur",blurEventHandler$1)}function bindKeys(t,e,{handler:i="keydown",preventDefault:s=!0}={}){const n="keydown"==i?keydownCallbacks:keyupCallbacks;e._pd=s,[].concat(t).map((t=>n[t]=e))}function unbindKeys(t,{handler:e="keydown"}={}){const i="keydown"==e?keydownCallbacks:keyupCallbacks;[].concat(t).map((t=>i[t]=0))}function keyPressed(t){return!!pressedKeys[t]}function getMethod(t){let e=t.substr(t.search(/[A-Z]/));return e[0].toLowerCase()+e.substr(1)}function removeInterceptor(t,e){let i=t.indexOf(e);-1!==i&&t.splice(i,1)}function registerPlugin(t,e){let i=t.prototype;i&&(i._inc||(i._inc={},i._bInc=function(t,e,...i){return this._inc[e].before.reduce(((e,i)=>{let s=i(t,...e);return s||e}),i)},i._aInc=function(t,e,i,...s){return this._inc[e].after.reduce(((e,i)=>{let n=i(t,e,...s);return n||e}),i)}),Object.getOwnPropertyNames(e).forEach((t=>{let s=getMethod(t);i[s]&&(i["_o"+s]||(i["_o"+s]=i[s],i[s]=function(...t){let e=this._bInc(this,s,...t),n=i["_o"+s].call(this,...e);return this._aInc(this,s,n,...t)}),i._inc[s]||(i._inc[s]={before:[],after:[]}),t.startsWith("before")?i._inc[s].before.push(e[t]):t.startsWith("after")&&i._inc[s].after.push(e[t]))})))}function unregisterPlugin(t,e){let i=t.prototype;i&&i._inc&&Object.getOwnPropertyNames(e).forEach((t=>{let s=getMethod(t);t.startsWith("before")?removeInterceptor(i._inc[s].before,e[t]):t.startsWith("after")&&removeInterceptor(i._inc[s].after,e[t])}))}function extendObject(t,e){let i=t.prototype;i&&Object.getOwnPropertyNames(e).forEach((t=>{i[t]||(i[t]=e[t])}))}class Pool{constructor({create:t,maxSize:e=1024}={}){let i;if(!t||!(i=t())||!(i.update&&i.init&&i.isAlive&&i.render))throw Error("Must provide create() function which returns an object with init(), update(), render(), and isAlive() functions");this._c=t,this.objects=[t()],this.size=0,this.maxSize=e}get(t={}){if(this.size===this.objects.length){if(this.size===this.maxSize)return;for(let t=0;t<this.size&&this.objects.length<this.maxSize;t++)this.objects.push(this._c())}let e=this.objects[this.size];return this.size++,e.init(t),e}getAliveObjects(){return this.objects.slice(0,this.size)}clear(){this.size=this.objects.length=0,this.objects.push(this._c())}update(t){let e,i=!1;for(let s=this.size;s--;)e=this.objects[s],e.update(t),e.isAlive()||(i=!0,this.size--);i&&this.objects.sort(((t,e)=>e.isAlive()-t.isAlive()))}render(){for(let t=this.size;t--;)this.objects[t].render()}}function factory$7(){return new Pool(...arguments)}function getIndices(t,e){let i=[],s=e.x+e.width/2,n=e.y+e.height/2,{x:a,y:o,width:r,height:h}=getWorldRect(t),c=t.y<n,l=t.y+t.height>=n;return t.x<s&&(c&&i.push(0),l&&i.push(2)),t.x+t.width>=s&&(c&&i.push(1),l&&i.push(3)),i}factory$7.prototype=Pool.prototype,factory$7.class=Pool;class Quadtree{constructor({maxDepth:t=3,maxObjects:e=25,bounds:i}={}){this.maxDepth=t,this.maxObjects=e;let s=getCanvas();this.bounds=i||{x:0,y:0,width:s.width,height:s.height},this._b=!1,this._d=0,this._o=[],this._s=[],this._p=null}clear(){this._s.map((function(t){t.clear()})),this._b=!1,this._o.length=0}get(t){let e=new Set;for(;this._s.length&&this._b;)return getIndices(t,this.bounds).map((i=>{this._s[i].get(t).map((t=>e.add(t)))})),Array.from(e);return this._o.filter((e=>e!==t))}add(...t){t.map((t=>{Array.isArray(t)?this.add.apply(this,t):this._b?this._a(t):(this._o.push(t),this._o.length>this.maxObjects&&this._d<this.maxDepth&&(this._sp(),this._o.map((t=>this._a(t))),this._o.length=0))}))}_a(t){getIndices(t,this.bounds).map((e=>{this._s[e].add(t)}))}_sp(t,e,i){if(this._b=!0,!this._s.length)for(t=this.bounds.width/2|0,e=this.bounds.height/2|0,i=0;i<4;i++)this._s[i]=new Quadtree({bounds:{x:this.bounds.x+(i%2==1?t:0),y:this.bounds.y+(i>=2?e:0),width:t,height:e},maxDepth:this.maxDepth,maxObjects:this.maxObjects}),this._s[i]._d=this._d+1,this._s[i]._p=this}}function factory$8(){return new Quadtree(...arguments)}function getAllNodes(t){let e=[];return t._dn?e.push(t._dn):t.children&&t.children.map((t=>{e=e.concat(getAllNodes(t))})),e}factory$8.prototype=Quadtree.prototype,factory$8.class=Quadtree;class Scene extends factory$2.class{init({id:t,name:e=t,cullObjects:i=!0,cullFunction:s=collides,...n}){const a=this._dn=document.createElement("section");a.tabIndex=-1,a.style=srOnlyStyle,a.id=t,a.setAttribute("aria-label",e),super.init({id:t,name:e,cullObjects:i,cullFunction:s,...n}),addToDom(a,this.context.canvas);let o=this.context.canvas;this.camera=factory$2({x:o.width/2,y:o.height/2,width:o.width,height:o.height,anchor:{x:.5,y:.5}}),this.camera._pc=()=>{super._pc.call(this.camera);this.context.canvas;this.camera._wx=this.camera.x*this.scaleX,this.camera._wy=this.camera.y*this.scaleY}}show(){this.hidden=this._dn.hidden=!1;let t=this.children.find((t=>t.focus));t?t.focus():this._dn.focus(),this.onShow()}hide(){this.hidden=this._dn.hidden=!0,this.onHide()}addChild(t,e){super.addChild(t,e),getAllNodes(t).map((t=>{this._dn.appendChild(t)}))}removeChild(t){super.removeChild(t),getAllNodes(t).map((t=>{addToDom(t,this.context.canvas)}))}destroy(){this._dn.remove(),this.children.map((t=>t.destroy&&t.destroy()))}update(t){this.hidden||super.update(t)}lookAt(t){let e=(t=t.world||t).x,i=t.y;t.scaleX&&(e/=t.scaleX,i/=t.scaleY),this.camera.x=e,this.camera.y=i,this._pc()}_pc(){super._pc(),this.camera&&this.camera._pc()}render(){let{x:t,y:e,width:i,height:s}=this.camera;this.sx=t*this.scaleX-i/2,this.sy=e*this.scaleY-s/2,this.hidden||super.render((t=>!this.cullObjects||this.cullFunction(t,this.camera)))}onShow(){}onHide(){}}function factory$9(){return new Scene(...arguments)}function parseFrames(t){if(+t===t)return t;let e=[],i=t.split(".."),s=+i[0],n=+i[1],a=s;if(s<n)for(;a<=n;a++)e.push(a);else for(;a>=n;a--)e.push(a);return e}factory$9.prototype=Scene.prototype,factory$9.class=Scene;class SpriteSheet{constructor({image:t,frameWidth:e,frameHeight:i,frameMargin:s,animations:n}={}){if(!t)throw Error("You must provide an Image for the SpriteSheet");this.animations={},this.image=t,this.frame={width:e,height:i,margin:s},this._f=t.width/e|0,this.createAnimations(n)}createAnimations(t){let e,i;for(i in t){let{frames:s,frameRate:n,loop:a}=t[i];if(e=[],void 0===s)throw Error("Animation "+i+" must provide a frames property");[].concat(s).map((t=>{e=e.concat(parseFrames(t))})),this.animations[i]=factory({spriteSheet:this,frames:e,frameRate:n,loop:a})}}}function factory$a(){return new SpriteSheet(...arguments)}function TileEngine(t){let{width:e,height:i,tilewidth:s,tileheight:n,context:a=getContext(),tilesets:o,layers:r}=t,h=e*s,c=i*n,l=document.createElement("canvas"),d=l.getContext("2d");l.width=h,l.height=c;let u={},p={},f=[],g=Object.assign({context:a,mapwidth:h,mapheight:c,_sx:0,_sy:0,_d:!1,get sx(){return this._sx},get sy(){return this._sy},set sx(t){this._sx=clamp(0,h-getCanvas().width,t),f.forEach((t=>t.sx=this._sx))},set sy(t){this._sy=clamp(0,c-getCanvas().height,t),f.forEach((t=>t.sy=this._sy))},render(){this._d&&(this._d=!1,this._p()),w(l)},renderLayer(t){let e=p[t],i=u[t];e||(e=document.createElement("canvas"),e.width=h,e.height=c,p[t]=e,g._r(i,e.getContext("2d"))),i._d&&(i._d=!1,e.getContext("2d").clearRect(0,0,e.width,e.height),g._r(i,e.getContext("2d"))),w(e)},layerCollidesWith(t,e){let{x:i,y:s,width:n,height:a}=getWorldRect(e),o=_(s),r=y(i),h=_(s+a),c=y(i+n),l=u[t];for(let t=o;t<=h;t++)for(let e=r;e<=c;e++)if(l.data[e+t*this.width])return!0;return!1},tileAtLayer(t,e){let i=e.row||_(e.y),s=e.col||y(e.x);return u[t]?u[t].data[s+i*g.width]:-1},setTileAtLayer(t,e,i){let s=e.row||_(e.y),n=e.col||y(e.x);u[t]&&(this._d=!0,u[t]._d=!0,u[t].data[n+s*g.width]=i)},setLayer(t,e){u[t]&&(this._d=!0,u[t]._d=!0,u[t].data=e)},addObject(t){f.push(t),t.sx=this._sx,t.sy=this._sy},removeObject(t){let e=f.indexOf(t);-1!==e&&(f.splice(e,1),t.sx=t.sy=0)},_r:function(t,e){e.save(),e.globalAlpha=t.opacity,(t.data||[]).map(((t,i)=>{if(!t)return;let s;for(let e=g.tilesets.length-1;e>=0&&(s=g.tilesets[e],!(t/s.firstgid>=1));e--);let n=s.tilewidth||g.tilewidth,a=s.tileheight||g.tileheight,o=s.margin||0,r=s.image,h=t-s.firstgid,c=s.columns||r.width/(n+o)|0,l=i%g.width*n,d=(i/g.width|0)*a,u=h%c*(n+o),p=(h/c|0)*(a+o);e.drawImage(r,u,p,n,a,l,d,n,a)})),e.restore()},_p:m,layerCanvases:p,layerMap:u},t);function _(t){return t/g.tileheight|0}function y(t){return t/g.tilewidth|0}function m(){g.layers&&g.layers.map((t=>{t._d=!1,u[t.name]=t,t.data&&!1!==t.visible&&g._r(t,d)}))}function w(t){const{width:e,height:i}=getCanvas(),s=Math.min(t.width,e),n=Math.min(t.height,i);g.context.drawImage(t,g.sx,g.sy,s,n,0,0,s,n)}return g.tilesets.map((e=>{let i=(window.__k?window.__k.dm.get(t):"")||window.location.href;if(e.source){if(!window.__k)throw Error('You must use "load" or "loadData" to resolve tileset.source');let t=window.__k.d[window.__k.u(e.source,i)];if(!t)throw Error(`You must load the tileset source "${e.source}" before loading the tileset`);Object.keys(t).map((i=>{e[i]=t[i]}))}if(""+e.image===e.image){if(!window.__k)throw Error('You must use "load" or "loadImage" to resolve tileset.image');let t=window.__k.i[window.__k.u(e.image,i)];if(!t)throw Error(`You must load the image "${e.image}" before loading the tileset`);e.image=t}})),m(),g}factory$a.prototype=SpriteSheet.prototype,factory$a.class=SpriteSheet;let kontra={Animation:factory,imageAssets:imageAssets,audioAssets:audioAssets,dataAssets:dataAssets,setImagePath:setImagePath,setAudioPath:setAudioPath,setDataPath:setDataPath,loadImage:loadImage,loadAudio:loadAudio,loadData:loadData,load:load,Button:factory$5,init:init,getCanvas:getCanvas,getContext:getContext,on:on,off:off,emit:emit,GameLoop:GameLoop,GameObject:factory$2,Grid:factory$6,degToRad:degToRad,radToDeg:radToDeg,angleToTarget:angleToTarget,rotatePoint:rotatePoint,randInt:randInt,seedRand:seedRand,lerp:lerp,inverseLerp:inverseLerp,clamp:clamp,setStoreItem:setStoreItem,getStoreItem:getStoreItem,collides:collides,getWorldRect:getWorldRect,keyMap:keyMap,initKeys:initKeys,bindKeys:bindKeys,unbindKeys:unbindKeys,keyPressed:keyPressed,registerPlugin:registerPlugin,unregisterPlugin:unregisterPlugin,extendObject:extendObject,initPointer:initPointer,getPointer:getPointer,track:track,untrack:untrack,pointerOver:pointerOver,onPointerDown:onPointerDown,onPointerUp:onPointerUp,pointerPressed:pointerPressed,Pool:factory$7,Quadtree:factory$8,Scene:factory$9,Sprite:factory$3,SpriteSheet:factory$a,Text:factory$4,TileEngine:TileEngine,Vector:factory$1};export default kontra;export{factory as Animation,factory$5 as Button,GameLoop,factory$2 as GameObject,factory$6 as Grid,factory$7 as Pool,factory$8 as Quadtree,factory$9 as Scene,factory$3 as Sprite,factory$a as SpriteSheet,factory$4 as Text,TileEngine,factory$1 as Vector,angleToTarget,audioAssets,bindKeys,clamp,collides,dataAssets,degToRad,emit,extendObject,getCanvas,getContext,getPointer,getStoreItem,getWorldRect,imageAssets,init,initKeys,initPointer,inverseLerp,keyMap,keyPressed,lerp,load,loadAudio,loadData,loadImage,off,on,onPointerDown,onPointerUp,pointerOver,pointerPressed,radToDeg,randInt,registerPlugin,rotatePoint,seedRand,setAudioPath,setDataPath,setImagePath,setStoreItem,track,unbindKeys,unregisterPlugin,untrack};